Attribute VB_Name = "Mainmodule"
Option Explicit

Public Stepper As Single

Public IsRunning             As Boolean

Public Windowed              As Boolean



Public tv                    As TrueVision3D.TVEngine

Public ReverseMouseY         As Boolean

Private PosX As Single, PosY As Single, PosZ As Single

Public Sub Main()
  InitializeEngine
  IsRunning = True
  ReverseMouseY = True
  StartGameLoop
End Sub

Public Sub InitializeEngine()
  Set tv = New TrueVision3D.TVEngine
  DriverDialog.Show vbModal
  
  If DriverDialog.Tag = "Cancel" Then
    End
  End If
  
  If DriverDialog.SelectedVideoModeWindowed Then
    Window.Show
    tv.Init3DWindowedMode Window.hWnd
    Windowed = True
  Else
    With DriverDialog
       tv.Init3DFullscreen .SelectedVideoModeWidth, .SelectedVideoModeHeight, _
                           .SelectedVideoModeColorFormat, .SelectedVideoModeTL, True, _
                           .SelectedVideoModeDepthFormat
    End With
  End If
  
  tv.SetSearchDirectory App.Path & "\Media"

  tv.DisplayFPS = True
  
  
  InitCoreComponents

  InitNonCoreComponents
End Sub

Public Sub StartGameLoop()
 GraphicEffect.FadeIn 2000

  
  Do While IsRunning
    If (Windowed) Then
      DoEvents
    End If
    DoLightEngine
    
    tv.Clear
    DoTrees
    
    Landscape.Render
    Atmosphere.Atmosphere_Render
    Scene.RenderAllMeshes
    Landscape.RenderWater True
    
    tv.RenderToScreen
    DoCamera
    DoInput
    
  Loop
End Sub

Private Sub InitCoreComponents()
  InitializeInput
  '--Not currently using this
  InitializeMaterialFactory
  '--Not currently using this.
  InitializeGraphicEffect
  InitializeLightEngine
  InitializeTextureFactory
  InitializeLandscape
  InitializeScene
  InitializeAtmosphere
  InitializeScreen
  InitializeCamera
  
End Sub

Private Sub InitNonCoreComponents()
  InitializeModels
  InitalizeTrees
  
End Sub

'************************
'Kill it all
'***********************
Public Sub EndGameLoop()
  IsRunning = False
  Set tv = Nothing
  Set Atmosphere = Nothing
  Set Landscape = Nothing
  Set Scene = Nothing
  Set Inp = Nothing
  Set Screen = Nothing
  Set CameraFPS = Nothing
  Set GraphicEffect = Nothing
  End
End Sub



