Attribute VB_Name = "TVAtmosphere"
Public Atmosphere As TrueVision3D.TVAtmosphere


Public Sub InitializeAtmosphere()
  Set Atmosphere = New TrueVision3D.TVAtmosphere
  InitializeSkyBox
  InitializeSun
  InitializeFog
End Sub

Private Sub InitializeSkyBox()
  With Atmosphere
    .SkyBox_Enable True
    .SkyBox_SetDistance 2000
    .SkyBox_SetTexture GetTex("SkyBack"), GetTex("SkyFront"), _
                       GetTex("SkyRight"), GetTex("SkyLeft"), _
                       GetTex("SkyTop"), GetTex("SkyBottom")
    
  End With
End Sub


Private Sub InitializeSkySphere()
  With Atmosphere
    .SkySphere_SetRadius 2000
    .SkySphere_SetTexture GetTex("SkySphere")
    .SkySphere_SetPolyCount 10
    .SkySphere_Enable True
  End With
End Sub

Private Sub InitializeFog()
  With Atmosphere
    .Fog_Enable True
    .Fog_SetColor 0.3, 0.3, 0.3, 1
    .Fog_SetType TV_FOG_EXP, TV_FOGTYPE_RANGE
    .Fog_Enable True
  End With
End Sub

Private Sub InitializeSun()
  With Atmosphere
    .Sun_SetPosition 300, 100, 10
    .Sun_SetTexture GetTex("Sun")
    .Sun_SetBillboardSize 0.2
    .Sun_Enable True
    .LensFlare_SetLensNumber 4
    .LensFlare_Enable True
    .LensFlare_SetLensParams 1, GetTex("Flare1"), 3, 30, RGBA(0.4, 0.3, 0, 0.5), RGBA(1, 1, 1, 0.5)
    .LensFlare_SetLensParams 2, GetTex("Flare2"), 1, 18, RGBA(0.4, 0.3, 0, 0.5), RGBA(1, 1, 1, 0.5)
    .LensFlare_SetLensParams 3, GetTex("Flare3"), 1.8, 15, RGBA(0.4, 0.3, 0, 0.5), RGBA(0.7, 1, 1, 0.5)
    .LensFlare_SetLensParams 4, GetTex("Flare4"), 2, 6, RGBA(1, 0.1, 0, 0.5), RGBA(0.5, 1, 1, 0.5)
  End With
End Sub

Public Sub SetWaterFog()
  With Atmosphere
    .Fog_SetParameters 1, 500, 0.0009
    .Fog_SetType TV_FOG_EXP, TV_FOGTYPE_PIXEL
    .Fog_SetColor 1, 1, 1, 1
    .Fog_Enable True
  End With

End Sub

Public Sub SetLandFog()
  With Atmosphere
      .Fog_SetParameters 1, 550, 0.0007
      .Fog_SetType TV_FOG_EXP, TV_FOGTYPE_PIXEL
      .Fog_SetColor 0.7, 0.7, 0.9, 1
      .Fog_Enable True
  End With
End Sub



