Attribute VB_Name = "TVLightEngine"
Public LightEngine As TrueVision3D.TVLightEngine
Public LightIndex As Integer
Public Light As D3DLIGHT8

Public Sub InitializeLightEngine()
  Set LightEngine = New TrueVision3D.TVLightEngine
  With Light
      'ambient light color multiplied with the objects material.
      'in this case we are using a dark 'grey' light
      .Ambient.A = 0.4
      .Ambient.r = 0.4
      .Ambient.G = 0.4
      .Ambient.b = 0.4
      .Type = D3DLIGHT_SPOT 'or spot or directional
      'diffuse is the color of the light, multiplied with the
      'objects material diffuse, in this case we use a white light
      .diffuse.A = 1
      .diffuse.r = 1
      .diffuse.G = 1
      .diffuse.b = 1
      'specular is the shininess of the light multiplied with the
      'objects material specural component
      .specular.A = 1
      .specular.r = 0.2
      .specular.G = 0.2
      .specular.b = 0.2
      .Direction = Vector3(0, -1, 0)
      .Position = Vector3(0, 400, 10)
      .Range = 1000
      .Attenuation0 = 0.1
      .Falloff = 1#
      .Phi = 3.14 / 4
      .Theta = Phi / 2#
  End With
  LightEngine.CreateLight Light, "Light"
  LightEngine.EnableLight(LightEngine.GetLightIndexByName("Light")) = True
  LightEngine.CreateLight Light, "Sun"
  LightEngine.EnableLight(LightEngine.GetLightIndexByName("Sun")) = True
End Sub

Public Sub DoLightEngine()
    LightEngine.UpdateLight LightEngine.GetLightIndexByName("Sun"), Light
End Sub



