Attribute VB_Name = "TVTextureFactory"
Public TextureFactory As TrueVision3D.TVTextureFactory
Public Sub InitializeTextureFactory()
  Set TextureFactory = New TrueVision3D.TVTextureFactory
    Dim TheTextureIndex As Long
    InitializeLandscapeTextures
    InitializeSkyTextures
    InitializeSunTextures
    InitializeTreeTextures
    InitializeOtherTextures
  End Sub

Private Sub InitializeLandscapeTextures()
  With TextureFactory
     'LOAD LANDSCAPE STUFF
    .LoadTexture "Landscape\grass.jpg", "Grass"
    .LoadTexture "Landscape\map.jpg", "HeightMap"
    .LoadTexture "Landscape\water.bmp", "water"
  End With
End Sub

Private Sub InitializeSkyTextures()
  With TextureFactory
    'LOAD SKY STUFF
    .LoadTexture "SkyBox\SkyRight.jpg", "SkyRight"
    .LoadTexture "SkyBox\SkyLeft.jpg", "SkyLeft"
    .LoadTexture "SkyBox\SkyBack.jpg", "SkyBack"
    .LoadTexture "SkyBox\SkyFront.jpg", "SkyFront"
    .LoadTexture "SkyBox\SkyTop.jpg", "SkyTop"
    .LoadTexture "SkyBox\SkyBottom.jpg", "SkyBottom"
  End With
End Sub

Private Sub InitializeSunTextures()
  With TextureFactory
    'Load Sun and flares
    .LoadTexture "Sun\Sun.jpg", "Sun"
    .LoadTexture "Sun\Flare1.jpg", "Flare1"
    .LoadTexture "Sun\Flare2.jpg", "Flare2"
    .LoadTexture "Sun\Flare3.jpg", "Flare3"
    .LoadTexture "Sun\Flare4.jpg", "Flare4"
  End With
End Sub

Private Sub InitializeTreeTextures()
  With TextureFactory
    'Load trees textures
    .LoadTexture "trees\GreenLeaves.bmp", "GreenLeaves", , , TV_COLORKEY_BLACK
    .LoadTexture "trees\GreenLeaf.bmp", "GreenLeaf", , , TV_COLORKEY_WHITE
    .LoadTexture "trees\pine.bmp", "Pine", , , TV_COLORKEY_BLACK
    .LoadTexture "trees\birch.jpg", "tree1"
    .LoadTexture "trees\tree2.jpg", "tree2"
    .LoadTexture "trees\tree3.jpg", "tree3"
  End With
End Sub

Private Sub InitializeOtherTextures()
  With TextureFactory
    .LoadTexture "Stonehenge\Henge.jpg", "Stone"
    .LoadTexture "Rocks\Rock.jpg", "Rock"
  End With
End Sub


